SoEnvironment(3)

NAME
SoEnvironment - The SoEnvironment class is a node for specifying global rendering parameters.

SYNOPSIS

#include <Inventor/nodes/SoEnvironment.h>

Inherits SoNode.

  Public Types
enum FogType { NONE = SoEnvironmentElement::NONE, HAZE = SoEnvironmentElement::HAZE, FOG = SoEnvironmentElement::FOG, SMOKE = SoEnvironmentElement::SMOKE }

  Public Member Functions
virtual SoType getTypeId (void) const
SoEnvironment (void)
virtual void GLRender (SoGLRenderAction *action)
virtual void callback (SoCallbackAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFFloat ambientIntensity
SoSFColor ambientColor
SoSFVec3f attenuation
SoSFEnum fogType
SoSFColor fogColor
SoSFFloat fogVisibility

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoEnvironment ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoEnvironment class is a node for specifying global rendering parameters. This node type provides the application programmer with the ability to set global parameters influencing lighting and fog.

FILE FORMAT/DEFAULTS:

Environment {
    ambientIntensity 0.2
    ambientColor 1 1 1
    attenuation 0 0 1
    fogType NONE
    fogColor 1 1 1
    fogVisibility 0
}

Member Enumeration Documentation

  enum SoEnvironment::FogType
Enumeration of available types of fog.

Enumerator

NONE
    No fog. Visibility will be equal for all objects, independent of distance to camera.

HAZE
    Fog where visibility will decrease linearly with distance to camera.

FOG Fog where visibility will decrease exponentially with distance to camera.

SMOKE
    Fog where visibility will decrease exponentially with the square of the distance to camera (simulating really thick fog).

Constructor & Destructor Documentation

  SoEnvironment::SoEnvironment (void)
Constructor.

  SoEnvironment::~SoEnvironment () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoEnvironment::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoEnvironment::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoEnvironment::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoEnvironment::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoEnvironment::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoEnvironment::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

Member Data Documentation

  SoSFFloat SoEnvironment::ambientIntensity
A global ambient value for the light intensity for the complete scene. This will provide some light even when there are no light sources defined for the scene.

Valid values is from 0.0 (no ambient light) to 1.0 (full ambient light intensity). Default value is 0.2.

  SoSFColor SoEnvironment::ambientColor
The color of the global ambient light. Defaults to full intensity white, i.e. <1.0, 1.0, 1.0>.

Each component of this RGB vector is multiplied with the scalar value of SoEnvironment::ambientIntensity.

  SoSFVec3f SoEnvironment::attenuation
Squared, linear, and constant light attenuation coefficients (in that order). Please note that this is the reverse order of how attenuation is usually specified.

  SoSFEnum SoEnvironment::fogType
The fog model. See SoEnvironment::FoType.

  SoSFColor SoEnvironment::fogColor
Color of fog. Defaults to full intensity white.

  SoSFFloat SoEnvironment::fogVisibility
The 'cut-off' distance from the camera where objects will be totally obscured by fog. If set to 0.0, the far plane distance will be used instead.

Default value is 0.0.

Author

Generated automatically by Doxygen for Coin from the source code.